<!DOCTYPE html>
<html>
<head>

	<title></title>
	 <meta name="viewport" content="width=device-width, initial-
         scale=1.0" />
    <!-- <style type="text/css">
     	input {
     		background-color: green;
     	}
     	#name{
     		background-color: red;
     	}
     	.testc{
     		background-color: blue
     	}
     </style> -->
     <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-giJF6kkoqNQ00vy+HMDP7azOuL0xtbfIcaT9wjKHr8RbDVddVHyTfAAsrekwKmP1" crossorigin="anonymous">
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/js/bootstrap.bundle.min.js" integrity="sha384-ygbV9kiqUc6oa4msXn9868pTtWMgiQaeYH7/t7LECLbyPA2x65Kgf80OJFdroafW" crossorigin="anonymous"></script>
</head>
<body  style="margin-left:10px;margin-right:10px;">
	<h2>Customer Management</h2>
	<hr/>
	<div>
	<form>
  <div class="col-md-4">
    <label class="form-label">Name</label>
    <input type="text" class="form-control" id="name">
  </div>
  <div class="col-md-4">
    <label class="form-label">Email</label>
    <input type="email" class="form-control" id="email">
  </div>
  <div class="col-md-4">
    <label class="form-label">Phone</label>
    <input type="text" class="form-control" id="phone">
  </div>
  <div class="col-md-4">
    <label class="form-label">Address</label>
    <input type="text" class="form-control" id="address">
  </div><br/>
  <button id="addSave" type="button" class="btn btn-primary" onclick="addCustomer();">Add</button>
  <button type="button" class="btn btn-secondary"  onclick="reset();">Cancel</button>
</form>
</div>
		<hr/>
		<input type="button" name="" value="Sort" onclick="doSort();"> |
		<label> Column:</label>
		<select name="column" id="columnSelect">
			<option value="name">name</option>
		    <option value="email">email</option>
		    <option value="address">address</option>
		    <option value="phone">phone</option>
		</select>
		<input type="text" id="searchText" placeholder="search text"> 
		<input type="button" name="" value="Search" onclick="doSearch();">
		<br/><br/>
		<table>
				<thead>
					<tr>
						<th>#</th>
						<th>Name</th>
						<th>Email</th>
						<th>Phone</th>
						<th>Address</th>
						<th>Edit</th>
						<th>Delete</th>
					</tr>
				</thead>
			<tbody id="result">
			</tbody>
		</table><br/><br/>
	
	<script type="text/javascript">
		var customers = [ 
			{id:1,name:'Vivek', email:'vivek@abc.com', phone:'8989389333',address:"Singapore"},
			{id:2,name:'Dev', email:'dev@abc.com', phone:'866u389333',address:"India"},
			{id:3,name:'Ameer', email:'ameer@abc.com', phone:'877779333',address:"Asia"},
			{id:4, name:'Dian', email:'dian@gmail.com', phone:"1234567876", address:'Singapore'},
			{id:5, name:'Apple', email:'dian@gmail.com', phone:"1234567876", address:'Singapore'},
			{id:6, name:'Orange', email:'dian@gmail.com', phone:"1234567876", address:'Singapore'}
			];

		var initCustomers = () => {
			var data = localStorage.getItem("_customers");
			if(data != null){
				customers = JSON.parse(localStorage.getItem("_customers"));
			}
		}
		var saveCustomer = () => {
			localStorage.setItem("_customers",JSON.stringify(customers));
		}
		var getCustomerById =  (id) => {
			for (var i = 0; i < customers.length; i++) {
				if (customers[i].id == id){
					return customers[i];
				}
			}
			return {};
		}
		var doSearch = () => {
			var searchText = document.getElementById('searchText').value.toLowerCase();
			var searchColumn = document.getElementById('columnSelect').value;
			console.log("searchText:"+searchText)
			console.log("searchColumn:"+searchColumn);

			//length 20
			var tempCustomers = customers.filter( (item) =>  {
				// customer.name
				if(item[searchColumn].toLowerCase().startsWith(searchText)){
					return 	item;
				}
			});
			displayCustomers(tempCustomers);
		}
		var doSort = () => {
			//sort by name
			customers = customers.sort((a,b) => {
				if(a.name < b.name){
					return -1;
				}else{
					return 1;
				}
				return 0;
			});
			displayCustomers(customers);
		}
		var reset = () => {
			document.getElementById('name').value="";
			document.getElementById('email').value="";
			document.getElementById('phone').value="";
			document.getElementById('address').value="";
			document.getElementById('addSave').value = "Add";
		}
		var selectCustomer = (id) => {
			slectedCustomerId = id; //global
			var customer = getCustomerById(id);
			document.getElementById('name').value = customer.name;
			document.getElementById('email').value = customer.email;
			document.getElementById('phone').value = customer.phone;
			document.getElementById('address').value = customer.address;
			document.getElementById('addSave').value = "Update";
		}
		var addCustomer = () => {
			var customer = {};
			customer.id = Date.now();
			customer.name = document.getElementById('name').value;
			customer.email = document.getElementById('email').value;
			customer.phone = document.getElementById('phone').value;
			customer.address = document.getElementById('address').value;

			if(typeof(slectedCustomerId) == "undefined" || slectedCustomerId == "") {
				customers.push(customer);
			}else{
				console.log("to update");
				customer.id = slectedCustomerId;
				var oldCustomer = getCustomerById(customer.id);
				oldCustomer.name = customer.name;
				oldCustomer.email = customer.email;
				oldCustomer.address = customer.address;
				oldCustomer.phone = customer.phone;
				slectedCustomerId = "";
			}
            
			reset();
			displayCustomers(customers);
			saveCustomer();
		}
	
		var deleteCustomer = (id) => {
			var tempArray = [];
			customers.map((record) => {
				if(record.id != id){
					tempArray.push(record);
				}
			})
			customers = tempArray;
			displayCustomers(customers);
			saveCustomer();
			//console.log("delete "+val1 +" from array");
			//document.getElementById('result').innerHTML = JSON.stringify(array);
		}
		var displayCustomers = (customers) => {
			//JSON.stringify(s);
			console.log(customers.length);
			const list = document.getElementById("result"); //result is the list
			list.innerHTML = "";
			for (var i=0; i < customers.length; i++  ) {
				let id = customers[i].id;
				const newRecord = document.createElement("tr");
				const newId = document.createElement("th");
				newId.innerHTML = customers[i].id;

				const newName = document.createElement("th");
				newName.innerHTML = customers[i].name;

				const newEmail = document.createElement("th");
				newEmail.innerHTML = customers[i].email;

				const newPhone = document.createElement("th");
				newPhone.innerHTML = customers[i].phone;

				const newAddress = document.createElement("th");
				newAddress.innerHTML = customers[i].address;

				newRecord.appendChild(newId);
				newRecord.appendChild(newName);
				newRecord.appendChild(newEmail);
				newRecord.appendChild(newPhone);
				newRecord.appendChild(newAddress);

				const newDeleteButton = document.createElement("th");
			  	
			  	const newButton = document.createElement("BUTTON");
			  	newButton.innerHTML = 'delete';  
			  	newButton.onclick = (e) => {
			  		//avoid default behaviour to post form data
			  		e.preventDefault();
			  		console.log('delete :'+id);
			  		deleteCustomer(id);
				}
				newDeleteButton.appendChild(newButton);

				const newEditButton = document.createElement("th");
			  	const newEButton = document.createElement("BUTTON");
			  	newEButton.innerHTML = 'edit';  
			  	newEButton.onclick = (e) => {
			  		//avoid default behaviour to post form data
			  		e.preventDefault();
			  		selectCustomer(id);
			  		console.log('edit :'+id);
			  		//deleteWord(word);
				}
				newEditButton.appendChild(newEButton);

				newRecord.appendChild(newEditButton);
				newRecord.appendChild(newDeleteButton);
			  	
			  	list.appendChild(newRecord);
			}
		}
		initCustomers();
		displayCustomers(customers);
	</script>
  
</body>
</html>